﻿using Syncfusion.UI.Xaml.Kanban;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace GettingStarted
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public ObservableCollection<BoardItems> Board = new ObservableCollection<BoardItems>();
        public MainPage()
        {
            this.InitializeComponent();
            SetupAgileBoardDetails();
            this.Loaded += MainPage_Loaded;
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //Added Columns to the Kanban based on the Items Count in the Board
            foreach(var item in Board)
            {
                KanbanColumn column = new KanbanColumn();
                column.Title = item.Category;
                //Added Cards to the corresponding columns based on the task count
                foreach(var task in item.Tasks)
                {
                    column.Cards.Add(new KanbanCardItem() { Content = task });
                }
                Kanban.Columns.Add(column);
            }
        }

        public void SetupAgileBoardDetails()
        {
            var open = new BoardItems() { Category = "Open" };
            open.Tasks = new ObservableCollection<Agile>();
            Agile task = new Agile();
            task.ID = 123;
            task.Title = "Maintenance";
            open.Tasks.Add(task);

            Board.Add(open);

            var InProgress = new BoardItems() { Category = "InProgress" };
            InProgress.Tasks = new ObservableCollection<Agile>();
            task = new Agile();
            task.ID = 246;
            task.Title = "Deployment";
            InProgress.Tasks.Add(task);
            Board.Add(InProgress);

            var Closed = new BoardItems() { Category = "Closed" };
            Closed.Tasks = new ObservableCollection<Agile>();
            task = new Agile();
            task.ID = 30;
            task.Title = "Analysis";
            Closed.Tasks.Add(task);

            task = new Agile();
            task.ID = 50;
            task.Title = "Testing";
            Closed.Tasks.Add(task);


            task = new Agile();
            task.ID = 3022;
            task.Title = "Development";
            Closed.Tasks.Add(task);
            Board.Add(Closed);

        }
    }

    //Custom Model for Kanban
    public class Agile
    {
        public int ID { get; set; }

        public string Title { get; set; }
    }

    public class BoardItems
    {
        public ObservableCollection<Agile> Tasks { get; set; }
        public int ID { get; set; }

        public string Title { get; set; }
        public string Category { get; set; }

        public int TaskCount { get; set; }
    }
}
